- Qt 6.9
- Active Qt
- Tools for ActiveQt
- The dumpcpp Tool (ActiveQt)
- Qt 6.9.3 Reference Documentation

Tools for ActiveQt ◦ The dumpdoc Tool (ActiveQt)

# The dumpcpp Tool (ActiveQt)

The `dumpcpp` tool generates a C++ namespace for a type library.

To generate a C++ namespace for a type library, call `dumpcpp` with the following command-line parameters:

Option | Result
--- | ---
input | Generate documentation for input. input can specify a type library file or a type library ID, or a CLSID or ProgID for an object
-o file | Writes the class declaration to file.h and meta object information to file.cpp
-n namespace | Generate a C++ namespace namespace
-nometaobject | Do not generate a .cpp file with the meta object information. The meta object is then generated in runtime.
-getfile libid | Print the filename for the typelibrary libid to stdout
-compat | Generate namespace with dynamicCall-compatible API
-controlname | Use the control class name instead of the UUID in setControl()
-v | Print version information
-h | Print help

Running the tool manually (and perhaps even checking the generated files into your version control system) is usually sufficient, as type libraries change very rarely. If your type library changes frequently, then you can integrate `dumpcpp` into the `qmake` build system. In your .pro file, list the type libraries you want to use in the TYPELIBS variable:

     TEMPLATE = app
     TARGET   = qutlook
     QT += widgets axcontainer

     TYPELIBS = $$system(dumpcpp -getfile {00062FFF-0000-0000-C000-000000000046})

The generated namespace will declare all enumerations, as well as one QAxObject subclass for each `coclass` and `interface` declared in the type library. coclasses marked with the `control` attribute will be wrapped by a QAxWidget subclass.

Those classes that wrap creatable coclasses (i.e. coclasses that are not marked as `noncreatable`) have a default constructor; this is typically a single class of type `Application`.

     Outlook::Application *outlook = new Outlook::Application;

All other classes can only be created by passing an IDispatch interface pointer to the constructor; those classes should however not be created explicitly. Instead, use the appropriate API of already created objects.

     Outlook::_NameSpace *session = outlook->Session();

All coclass wrappers also have one constructors taking an interface wrapper class for each interface implemented.

     Outlook::NameSpace *session = outlook->Session();

You have to create coclasses to be able to connect to signals of the subobject. Note that the constructor deletes the interface object, so the following will cause a segmentation fault:

     Outlook::_NameSpace *tmp = outlook->Session();
     Outlook::NameSpace *session = new Outlook::NameSpace(tmp);
     delete tmp; // or any other use of tmp: segfault

If the return type is of a coclass or interface type declared in another type library you have to include the namespace header for that other type library before including the header for the namespace you want to use (both header have to be generated with this tool).

By default, methods and property returning subobjects will use the type as in the type library. The caller of the function is responsible for deleting or reparenting the object returned. If the `-compat` switch is set, properties and method returning a COM object have the return type `IDispatch*`, and the namespace will not declare wrapper classes for interfaces.

In this case, create the correct wrapper class explicitly:

     Outlook::NameSpace *session = new Outlook::NameSpace(outlook->Session());

You can of course use the IDispatch* returned directly, in which case you have to call `Release()` when finished with the interface.

All classes in the namespace are tagged with a macro that allows you to export or import them from a DLL. To do that, declare the macro to expand to `__declspec(dllimport/export)` before including the header file.

To build the tool you must first build the QAxContainer library. Then run your make tool in `tools/dumpcpp`.

Tools for ActiveQt ◦ The dumpdoc Tool (ActiveQt)